function LoadPuzzle(puzzle)

	game_untouched = true;
	
	tip.one = 0;
	tip.two = 0;
	tip.show = false;
	
	selected1 = -1;
	selected2 = -1;
	
	for i = 0, 144 do
		field.x[i] = nil;
		field.y[i] = nil;
		field.z[i] = nil;
		field.img[i] = nil;
		field.l[i] = nil;
		field.r[i] = nil;
		field.u[i] = nil;
		field.d[i] = nil;
	end;

	dofile("assets/puzzle/" .. puzzle);

	TX = 0; TY = 0;
	
	DrawGame(0);
	DrawSidebar();
	tiles = CountTiles();
	moves = CountMoves();
	DrawBar();
	
end;

function InRect(rx, ry, rw, rh, x, y)

	return (x >= rx) and (x < rx + rw) and (y >= ry) and (y < ry + rh);

end;

function SelectTile()

	local selected = -1;
	local last_z = -1;
	
	for i = 0, 144 do
		if field.img[i] ~= nil then
			x = (tilew - 4) * field.x[i] - field.z[i] * 4 - zoom_offset_x;
			y = (tileh - 4) * field.y[i] - field.z[i] * 4 - zoom_offset_y;
			
			if InRect(x, y, tilew, tileh, TX, TY) then
				if field.z[i] > last_z then selected = i; end;
			end;
		end;
	end;
	
	if selected ~= -1 then
		if selected1 == -1 then
			selected1 = selected;
		else
			selected2 = selected;
		end;
	end;
end;

function CountTiles()

	local c = 0;

	for i = 0, 144 do
		if field.img[i] ~= nil then c = c + 1; end;
	end;

	return c;
	
end;

function EvaluateTiles()

	tip.show = false;

	if selected1 == selected2 then Fail(); return 0; end;
	
	if field.img[selected1] == field.img[selected2] then
		if IsFree(selected1) and IsFree(selected2) then 
			Success();
			return 1;
		else
			Fail();
			return 0;
		end;
	else
		Fail();
		return 0;
	end;
	
end;

function CountMoves()

	local m = 0;

	for i = 0, 144 do
		if field.img[i] ~= nil then
			if IsFree(i) then
				for e = 0, 144 do
					if e ~= i then
						if field.img[e] ~= nil then
							if IsFree(e) then
								if field.img[i] == field.img[e] then m = m + 1; tip.one = i; tip.two = e; end;
							end;
						end;
					end;
				end;
			end;
		end;
	end;

	return m / 2;
	
end;

function IsFree(num)

	return ((field.l[num] == nil or field.r[num] == nil) and field.u[num] == nil);
	
end;

function Shuffle(array, size)

	for i = 0, size do
		array = Swap(array, i, math.random(0, size));
	end;
	
	return array;

end;

function Swap(array, a, b)

	local tmp = array[a];
	array[a] = array[b];
	array[b] = tmp;

	return array;
	
end;