function cls()

	screen.fillrect(0, 0, 400, 240, cWhite);
	
end;

function Init()
	
	math.randomseed(os.ostime());
	
	cls();
	
	-- load tile images
	tile[0] = image.load("assets/image/1.png");
	tile[1] = image.load("assets/image/2.png");
	tile[2] = image.load("assets/image/3.png");
	tile[3] = image.load("assets/image/4.png");
	tile[4] = image.load("assets/image/5.png");
	tile[5] = image.load("assets/image/6.png");
	tile[6] = image.load("assets/image/7.png");
	tile[7] = image.load("assets/image/8.png");
	tile[8] = image.load("assets/image/9.png");
	
	tile[9] = image.load("assets/image/bamboo1.png");
	tile[10] = image.load("assets/image/bamboo2.png");
	tile[11] = image.load("assets/image/bamboo3.png");
	tile[12] = image.load("assets/image/bamboo4.png");
	tile[13] = image.load("assets/image/bamboo5.png");
	tile[14] = image.load("assets/image/bamboo6.png");
	tile[15] = image.load("assets/image/bamboo7.png");
	tile[16] = image.load("assets/image/bamboo8.png");
	tile[17] = image.load("assets/image/bamboo9.png");
	
	tile[18] = image.load("assets/image/number1.png");
	tile[19] = image.load("assets/image/number2.png");
	tile[20] = image.load("assets/image/number3.png");
	tile[21] = image.load("assets/image/number4.png");
	tile[22] = image.load("assets/image/number5.png");
	tile[23] = image.load("assets/image/number6.png");
	tile[24] = image.load("assets/image/number7.png");
	tile[25] = image.load("assets/image/number8.png");
	tile[26] = image.load("assets/image/number9.png");
	
	tile[27] = image.load("assets/image/dragonred.png");
	tile[28] = image.load("assets/image/dragongreen.png");
	tile[29] = image.load("assets/image/dragonwhite.png");
	tile[30] = image.load("assets/image/windnorth.png");
	tile[31] = image.load("assets/image/windeast.png");
	tile[32] = image.load("assets/image/windsouth.png");
	tile[33] = image.load("assets/image/windwest.png");
	tile[34] = image.load("assets/image/special1.png");
	tile[35] = image.load("assets/image/special2.png");
	tile[36] = tile[27]; -- too lazy to paint another special tile, so red dragon is two times in the puzzle :)
	
	
	-- system images
	bg = image.load("assets/image/bg.png");
	bthint = image.load("assets/image/bthint.png");
	btexit = image.load("assets/image/btexit.png");
	btzoomout = image.load("assets/image/btzoomout.png");
	btrestart = image.load("assets/image/btrestart.png");
	btnext = image.load("assets/image/btnext.png");
	yn = image.load("assets/image/yn.png");
	frameblue = image.load("assets/image/frameblue.png");
	framered = image.load("assets/image/framered.png");
	framegreen = image.load("assets/image/framegreen.png");
	
end;

function DrawGame(big)

	local x, y, z
	
	bg:draw(0, 0, 0, 0, 400, 228);

	if big == 1 then
		zoom_offset_x = math.floor(TX / sw * 400);
		zoom_offset_y = math.floor(TY / sh * 240);
	end;
	
	for i = 0, 144 do
		if field.img[i] ~= nil then
			if big == 0 then
				x, y, z = field.x[i], field.y[i], field.z[i];
				field.img[i]:draw(x * (tilews - 2) - z * 2, y * (tilehs - 2) - z * 2, tilews, tilehs);
			else
				x = (tilew - 4) * field.x[i] - zoom_offset_x;
				y = (tileh - 4) * field.y[i] - zoom_offset_y;
				z = field.z[i] * 4;
			
				field.img[i]:draw(x - z, y - z);
			end;
		end;
	end;
		
	if selected1 > -1 then
		if big == 0 then
			x, y, z = field.x[selected1], field.y[selected1], field.z[selected1];
			frameblue:draw(x * (tilews - 2) - z * 2, y * (tilehs - 2) - z * 2, tilews, tilehs);
		else
			x = (tilew - 4) * field.x[selected1] - zoom_offset_x;
			y = (tileh - 4) * field.y[selected1] - zoom_offset_y;
			z = field.z[selected1] * 4;
			frameblue:draw(x - z, y - z);
		end;
	end;
	
	if tip.show == true then
		if big == 0 then
			x, y, z = field.x[tip.one], field.y[tip.one], field.z[tip.one];
			framegreen:draw(x * (tilews - 2) - z * 2, y * (tilehs - 2) - z * 2, tilews, tilehs);
		
			x, y, z = field.x[tip.two], field.y[tip.two], field.z[tip.two];
			framegreen:draw(x * (tilews - 2) - z * 2, y * (tilehs - 2) - z * 2, tilews, tilehs);
		else
			x, y, z = (tilew - 4) * field.x[tip.one] - zoom_offset_x, (tileh - 4) * field.y[tip.one] - zoom_offset_y, field.z[tip.one] * 4;
			framegreen:draw(x - z, y - z, tilew - 4, tileh);
		
			x, y, z = (tilew - 4) * field.x[tip.two] - zoom_offset_x, (tileh - 4) * field.y[tip.two] - zoom_offset_y, field.z[tip.two] * 4;
			framegreen:draw(x - z, y - z, tilew - 4, tileh);
		end;
	end;
	
	if big == 1 then
		btzoomout:draw(300, 0);
	end;
	
end;

function DrawBar()

	local timer = 0;
	local mins, secs = 0, 0;
	
	bg:draw(0, 0, 0, 228, 400, 240);
	
	text.color(cBlack);
	text.size(12);

	-- tile count
	text.draw(5, 228, "Tiles left: " .. tostring(tiles));
	
	-- game timer
	timer = math.floor((os.ostime() - gametime) / 1000);
	secs = (timer % 60);
	mins = math.floor(timer / 60);
	
	if secs < 10 then secs = "0" .. secs; end;
	
	text.draw(90, 228, "Time spent: " .. mins .. ":" .. secs);
	
	-- possible moves
	text.draw(200, 228, "Matches: " .. moves);
	
	text.size(8);
	text.draw(365, 232, "ZaP 2010");
	
end;

function GameEnd(win)

	text.size(30);
	text.color(cBlack);
	
	if win == true then
		text.draw(0, 105, "You won!", "center", 400);
	else
		text.draw(0, 105, "You failed!", "center", 400);
	end;

end;

function DrawSidebar()

	local x, y, z = 0, 0, 0;

	DrawGame(0);
	
	bthint:draw(290, 24);
	btnext:draw(290, 100);
	btrestart:draw(290, 140);
	btexit:draw(290, 180);
	
	-- hint button
	if InRect(290, 24, 100, 30, TX, TY) then
		tip.show = true;
	
		x, y, z = field.x[tip.one], field.y[tip.one], field.z[tip.one];
		framegreen:draw(x * (tilews - 2) - z * 2, y * (tilehs - 2) - z * 2, tilews, tilehs);
		
		x, y, z = field.x[tip.two], field.y[tip.two], field.z[tip.two];
		framegreen:draw(x * (tilews - 2) - z * 2, y * (tilehs - 2) - z * 2, tilews, tilehs);
		
		screen.update();
	end;
	
	-- next puzzle button
	if InRect(290, 100, 100, 30, TX, TY) then
		currentpuzzle = currentpuzzle + 1;
		if puzzles[currentpuzzle] == nil then currentpuzzle = 0; end;
	
		if game_untouched then
			LoadPuzzle(puzzles[currentpuzzle]);
		else
			if DlgYN() == true then
				LoadPuzzle(puzzles[currentpuzzle]);
			else
				DrawGame(0);
				DrawSidebar();
			end;
		end;
	end;
	
	-- restart button
	if InRect(290, 140, 100, 30, TX, TY) then
		if game_untouched then
			LoadPuzzle(puzzles[currentpuzzle]);
		else
			if DlgYN() == true then
				LoadPuzzle(puzzles[currentpuzzle]);
			else
				DrawGame(0);
				DrawSidebar();
			end;
		end;
	end;
	
	-- exit button
	if InRect(290, 180, 100, 30, TX, TY) then
		if DlgYN() == true then
			gameend = true;
		else
			DrawGame(0);
			DrawSidebar();
		end;
	end;

end;

function DlgYN()
	
	yn:draw(0, 0);
	
	screen.update();
	
	while true do
	
		if control.read(1) == 1 then
			if control.isTouch() == 1 then
				if touch.click() == 1 then
					TX, TY = touch.pos();
					if InRect(67, 143, 100, 30, TX, TY) then
						return true;
					else
						break;
					end;
				end;	
			end;
		end;
	
		os.sleep(2);
	
	end;
	
	return false;
	
end;

function Fail()

	DrawGame(0);

	x, y, z = field.x[selected2], field.y[selected2], field.z[selected2];
	framered:draw(x * (tilews - 2) - z * 2, y * (tilehs - 2) - z * 2, tilews, tilehs);
	screen.update();
	os.sleep(50);
	screen.update();
	
	selected1 = -1;
	selected2 = -1;
	
	DrawGame(0);
	DrawSidebar();
	screen.update();
	
end;

function Success()

	tip.one = -1;
	tip.two = -1;
	
	DrawGame(0);

	x, y, z = field.x[selected2], field.y[selected2], field.z[selected2];
	framegreen:draw(x * (tilews - 2) - z * 2, y * (tilehs - 2) - z * 2, tilews, tilehs);
	screen.update();
	os.sleep(50);

	field.x[selected1] = nil;
	field.y[selected1] = nil;
	field.z[selected1] = nil;
	field.img[selected1] = nil;
	
	if field.l[selected1] ~= nil then field.r[field.l[selected1]] = nil; end;
	if field.r[selected1] ~= nil then field.l[field.r[selected1]] = nil; end;
	if field.d[selected1] ~= nil then field.u[field.d[selected1]] = nil; end;
	
	field.l[selected1] = nil;
	field.r[selected1] = nil;
	field.u[selected1] = nil;
	field.d[selected1] = nil;
	
	field.x[selected2] = nil;
	field.y[selected2] = nil;
	field.z[selected2] = nil;
	field.img[selected2] = nil;
	
	if field.l[selected2] ~= nil then field.r[field.l[selected2]] = nil; end;
	if field.r[selected2] ~= nil then field.l[field.r[selected2]] = nil; end;
	if field.d[selected2] ~= nil then field.u[field.d[selected2]] = nil; end;
	
	field.l[selected2] = nil;
	field.r[selected2] = nil;
	field.u[selected2] = nil;
	field.d[selected2] = nil;
	
	selected1 = -1;
	selected2 = -1;
	
	DrawGame(0);
	DrawSidebar();
	screen.update();
	
end;